
if __name__ == "__main__":
    import os
    os.system("python MY_MC3.py")
    exit()


from direct.actor.Actor import Actor

from panda3d.core import AmbientLight
from panda3d.core import DirectionalLight
from panda3d.core import Vec3
from panda3d.core import Vec4
from panda3d.core import Point3
from panda3d.core import LPoint3
from panda3d.core import TransformState
from panda3d.core import BitMask32
from panda3d.core import Filename
from panda3d.core import PNMImage
from panda3d.core import NodePath
from panda3d.core import PandaNode

from panda3d.core import CardMaker
from panda3d.core import TexturePool, Texture
from panda3d.core import TransparencyAttrib
from panda3d.core import Material
from panda3d.core import GeomNode
from panda3d.core import GeomLines
from panda3d.core import GeomVertexData
from panda3d.core import GeomVertexWriter
from panda3d.core import GeomVertexFormat
from panda3d.core import Geom
from panda3d.core import Material
from panda3d.core import ColorBlendAttrib
from panda3d.core import ShaderAttrib
from panda3d.core import GraphicsPipe, GraphicsOutput


from panda3d.bullet import BulletWorld
from panda3d.bullet import BulletPlaneShape
from panda3d.bullet import BulletBoxShape
from panda3d.bullet import BulletSphereShape
from panda3d.bullet import BulletRigidBodyNode
from panda3d.bullet import BulletGhostNode
from panda3d.bullet import BulletDebugNode
from panda3d.bullet import BulletCapsuleShape
from panda3d.bullet import BulletCharacterControllerNode
from panda3d.bullet import BulletHeightfieldShape
from panda3d.bullet import BulletTriangleMesh
from panda3d.bullet import BulletTriangleMeshShape
from panda3d.bullet import ZUp
from panda3d.bullet import BulletGenericConstraint

import sys
import math
from itertools import count

def intv(v):
    x, y, z = v
    # 坑爹，panda3d的低精度向量运算有误差，int()有时会相差1
    return round(x), round(y), round(z)

@global_reg
class PageGame(Page):
    def __init__(self, root):
        self.root = root
        self.world = None
        self.bulletworld = None
        self.debugp = None
        
        self.character = None
        self.speedx = 0
        self.speedy = 0
        self.cubef = None
        
        self.block_data = {}
        
        self.booms = []
        
        
    def load(self, mes):
        # ~ if "done" in mes:
            # ~ return
        
        

        # Input
        

        # ~ self.accept('/', self.cmd)
        # ~ def chm(n):
                # ~ if n == 1:
                        # ~ self.mode = "shoot"
                # ~ elif n == 2:
                        # ~ self.mode = "block"
        
                
        
        # ~ self.accept('space', self.doJump)
        # ~ inputState.watchWithModifiers('forward', 'w')
        # ~ inputState.watchWithModifiers('left', 'a')
        # ~ inputState.watchWithModifiers('reverse', 's')
        # ~ inputState.watchWithModifiers('right', 'd')
        
        self.move_control = MoveControl(self)
        self.fixed_control = FixedControl(self)
        self.fixed_control.reg()
        self.move_control.reg()
        self.hands_control = HandsControl(self)
        self.hands_control.reg()
        
        # Task
        self.root.update_list.append(self.update)
        self.root.reg_timer(2, self.setenemyapi)
        
        # Physics
        self.make_scene()
        
        # data 
        # ~ self.mode = "shoot"
        
        
    
    def make_scene(self):
        K = 0.3
        alight = AmbientLight('ambientLight')
        alight.set_color(Vec4(K, K, K, 1))
        alightp = render.attach_new_node(alight)
        
        
        K = 0.8
        dlight = DirectionalLight('directionalLight')
        dlight.set_direction(Vec3(1, 1.6, -0.65))
        dlight.set_color(Vec4(K, K, K, 1))
        dlightp1 = render.attach_new_node(dlight)
        
        dlight = DirectionalLight('directionalLight2')
        dlight.set_direction(Vec3(-1, -1.6, -0.65))
        dlight.set_color(Vec4(K, K, K, 1))
        dlightp2 = render.attach_new_node(dlight)

        render.clearLight()
        render.setLight(alightp)
        render.setLight(dlightp1)
        render.setLight(dlightp2)
        
        
        

        # World
        self.world = render.attach_new_node('World')
        self.debugp = self.world.attach_new_node(BulletDebugNode('Debug'))
        self.debugp.show()

        self.bulletworld = BulletWorld()
        self.bulletworld.set_gravity(Vec3(0, 0, -9.81 * 3))
        self.bulletworld.set_debug_node(self.debugp.node())
        
        # zhun xin
        tex = TexturePool.loadTexture("models/zhunxin.png")
        cm = CardMaker("zhunxin")
        cm.setFrame(-8, 8, -8, 8)
        cmn = self.root.pixel2d.attach_new_node(cm.generate())
        cmn.setTexture(tex)
        hw, hh = self.root.hsize
        cmn.setPos(hw, 0,    -hh )
        cmn.setTransparency(TransparencyAttrib.MAlpha)
        
        # Ground
        # ~ shape = BulletPlaneShape(Vec3(0, 0, 1), 0)
        # ~ img = PNMImage(Filename('models/elevation2.png'))
        # ~ shape = BulletHeightfieldShape(img, 0, ZUp)
        shape = BulletBoxShape(Vec3(50, 50 ,1))
        np = self.world.attach_new_node(BulletRigidBodyNode('Ground'))
        np.node().addShape(shape)
        np.setPos(0, 0, -1)
        np.setCollideMask(BitMask32.allOn())
        self.bulletworld.attach_rigid_body(np.node())

        
        # Character

        h = 1.8
        w = 0.4
        shape = BulletCapsuleShape(w, h - 2 * w, ZUp)
        self.charactern = BulletCharacterControllerNode(shape, 0.4, "player")       # character node
        self.charactern.setGravity(20)
        self.charactern.set_max_slope(20)
        self.character = self.world.attach_new_node(self.charactern)
        # ~ self.character.setPos(-30, 0, 0)
        self.character.setPos(-15, 0, 0)
        self.character.setH(45)
        self.character.setH(270)
        # ~ self.characterNP.setCollideMask(BitMask32.allOn())
        self.character.setCollideMask(BitMask32(0b00000111))        # character mask
        self.bulletworld.attach_character(self.charactern)

        self.actor = Actor('models/ralph/ralph.egg', {
                                                 'run' : 'models/ralph/ralph-run.egg',
                                                 'walk' : 'models/ralph/ralph-walk.egg',
                                                 'jump' : 'models/ralph/ralph-jump.egg'})
        # ~ self.actor.reparentTo(self.characterNP)         # do not show myself
        self.actor.setScale(0.3048) # 1ft = 0.3048m
        self.actor.setH(180)
        self.actor.setPos(0, 0, -1)
        
        
        # base block
        
        myMaterial = Material()
        myMaterial.setShininess(5.0)
        myMaterial.setAmbient((1, 1, 1, 1)) #Make this material blue

        self.box = loader.loadModel('models/box2.egg')
        self.box.setMaterial(myMaterial)
        
        ######################################################SHADER#####################
        self.box2 = self.box.__copy__()
        self.box2.set_color(Vec4(1, 0, 1, 1))
        self.box2.set_transparency(True)
        
        # ~ myMaterial = Material()
        # ~ myMaterial.setShininess(5.0)
        # ~ myMaterial.setAmbient((0.5, 1, 0.5, 1)) #Make this material blue
        # ~ self.box2.setMaterial(myMaterial)
        
        sh = loader.loadShader("shaders/mysh1.sha")
        self.box2.setShader(sh)
        
        self.modelbuffer = self.root.makeFBO("model buffer", 1)
        
        #self.glowBuffer = base.win.makeTextureBuffer("Glow scene", 800, 600)
        #self.glowBuffer = base.win.makeTextureBuffer("Glow scene", 800, 600)
        self.texDepth = Texture()
        self.texDepth.setFormat(Texture.FDepthStencil)
        self.texAlbedo = Texture()
        self.texNormal = Texture()
        #self.texFinal = Texture()

        self.modelbuffer.addRenderTexture(self.texDepth,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPDepthStencil)
        self.modelbuffer.addRenderTexture(self.texAlbedo,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPColor)
        self.modelbuffer.addRenderTexture(self.texNormal,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPAuxRgba0)
        
        # ~ self.glowBuffer.setSort(-3)
        # ~ self.glowBuffer.setClearColor(Vec4(0, 0, 0, 1))
        self.glowCamera = base.makeCamera(
            self.modelbuffer, lens=base.cam.node().getLens())
        
        tempnode = NodePath(PandaNode("temp node"))
        tempnode.setShader(loader.loadShader("shaders/glass_normal.sha"))
        self.glowCamera.node().setInitialState(tempnode.getState())
        
        # ~ attrib = ShaderAttrib.make()
        # ~ attrib = attrib.setShader(sh)
        # ~ attrib = attrib.setShaderInput("tint", (1.0, 0.5, 0.5, 1.0))
        # ~ self.glowCamera.node().setInitialState(attrib)
        
        
        self.modelbuffer.addRenderTexture(self.texDepth,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPDepthStencil)
        self.modelbuffer.addRenderTexture(self.texAlbedo,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPColor)
        # ~ self.modelbuffer.addRenderTexture(self.texNormal,
            # ~ GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPAuxRgba2)
        self.modelbuffer.addRenderTexture(self.texNormal,
            GraphicsOutput.RTMBindOrCopy, GraphicsOutput.RTPDepth)
        
        self.modelbuffer.setSort(1)
        # ~ self.modelbuffer.setClearColor((1, 0, 0, 1))
        self.modelbuffer.set_clear_active(self.modelbuffer.RTPAuxRgba0, True)
        
        # ~ self.finalcard = self.glowBuffer.getTextureCard()
        # ~ self.finalcard = self.texDepth
        # ~ self.finalcard.reparentTo(render2d)
        # ~ self.finalcard.reparentTo(pixel2d)
        # ~ self.finalcard.setAttrib(ColorBlendAttrib.make(ColorBlendAttrib.MAdd))
        
        # ~ cm = CardMaker("full")
        # ~ #cm.set_frame(-1, 1, -1, 1)
        # ~ cm.set_frame(-0.5, 0.5, -0.5, 0.5)
        # ~ s = self.world.attach_new_node(cm.generate())
        # ~ s.setTexture(self.texNormal)
        # ~ s.reparentTo(render2d)
        # ~ s.setAttrib(ColorBlendAttrib.make(ColorBlendAttrib.MAdd))
        
        self.card = self.modelbuffer.getTextureCard()
        self.card.setTexture(self.texNormal)
        self.card.reparentTo(render2d)
        self.card.setAttrib(ColorBlendAttrib.make(ColorBlendAttrib.MAdd))
        
        
        self.modelbuffer.setSort(1)
        self.root.win.setSort(2)
        
        self.block_table = {1: self.box, 2: self.box2}
        
        # shoot ball
        # ~ self.ball = loader.loadModel('models/ball.egg')
        self.ball = loader.loadModel('models/pyramid.egg')
        
        
        
        # cube frame
        
        vdata = GeomVertexData('cube_data', GeomVertexFormat.getV3(), Geom.UHStatic)
        vertex = GeomVertexWriter(vdata, 'vertex')
        vertex.addData3f(-0.5, -0.5, -0.5)
        vertex.addData3f(0.5, -0.5, -0.5)
        vertex.addData3f(0.5, 0.5, -0.5)
        vertex.addData3f(-0.5, 0.5, -0.5)
        vertex.addData3f(-0.5, -0.5, 0.5)
        vertex.addData3f(0.5, -0.5, 0.5)
        vertex.addData3f(0.5, 0.5, 0.5)
        vertex.addData3f(-0.5, 0.5, 0.5)
        
        prim = GeomLines(Geom.UHStatic)

        prim.addVertices(0, 1)
        prim.addVertices(1, 2)
        prim.addVertices(2, 3)
        prim.addVertices(3, 0)
        prim.addVertices(4, 5)
        prim.addVertices(5, 6)
        prim.addVertices(6, 7)
        prim.addVertices(7, 4)
        prim.addVertices(0, 4)
        prim.addVertices(1, 5)
        prim.addVertices(2, 6)
        prim.addVertices(3, 7)
        
        geom = Geom(vdata)
        geom.addPrimitive(prim)

        cubefn = GeomNode('cubef')
        cubefn.addGeom(geom)
        
        self.cubef = self.world.attach_new_node(cubefn)
        self.cubef.set_color(Vec3(0, 0, 0))
        # ~ self.cubef.set_scale(Vec3(1.005, 1.005, 1.005))
        self.cubef.hide()
        
        
        
        self.root.bufferViewer.setPosition("llcorner")
        self.root.bufferViewer.setCardSize(0, 0.40)
        self.root.bufferViewer.setLayout("vline")
        
        def f():
            self.root.bufferViewer.toggleEnable()
            self.modelbuffer.setClearColorActive(True)
            self.modelbuffer.setClearDepthActive(True)
            # ~ self.modelbuffer.set_clear_stencil_active(True)
        self.root.accept("v", f)
        
        
        # 建筑
        for i in range(-5, 6):
            for j in range(-5, 6):
                for k in range(5):
                    a = min(abs(-5 - i), abs(5 - i))
                    b = min(abs(-5 - j), abs(5 - j))
                    c = min(abs(0 - k), abs(4 - k))
                    if (a == 0) + (b == 0) + (c == 0) >= 2:
                        self.setblockapi((i, j, k))
                        
        for i in range(-1, 2):
            for j in range(1):
                for k in range(3):
                    self.setblockapi((i, j, k), 2)

    def update(self, dt):
        dt = globalClock.getDt()
        
        self.bulletworld.doPhysics(dt, 4, 1./240.)
            
        
        # 手雷
        
        l2 = []
        for t in self.booms:
            boom, bh1, bh2 = t
            trans = boom.get_transform()
            bh1.set_transform(trans)
            bh2.set_transform(trans)
            
            if bh1.getNumOverlappingNodes() > 0:
                print("boom fall")
                p_me = boom.get_transform().get_pos()
                for rb in bh2.getOverlappingNodes():
                    if rb.has_python_tag("enemyhook"):
                        print("boom 1")
                        p_he = rb.get_transform().get_pos()
                        d = p_he - p_me
                        
                        # ~ n.set_python_tag("blood", blood)
                        rb.set_active(True)
                        l = d.length()
                        print("boom length", l)
                        print("boom v", (10 / (l + 2)) * 80)
                        d.normalize()
                        v = d * (10 / (l + 2)) * 80
                        
                        v.z = v.z * 2
                        rb.apply_impulse(v, Point3(0, 0, 0))
                self.bulletworld.removeRigidBody(boom)
                self.bulletworld.removeGhost(bh1)
                self.bulletworld.removeGhost(bh2)
                l2.append(t)
        
        for boom in l2:
            self.booms.remove(boom)
                        

        
        

    def reg_timer(self, name, t, cb):
        self.timer[name] = [t, t, cb]
    
    def unreg_timer(self, name):
        del self.timer[name]
        
    
    def cleanup(self):
        self.bulletworld = None
        self.world.removeNode()


    def setblockapi(self, t, type=1):
        x, y, z = t
        if not isinstance(x, int):
            raise TypeError("setblockapi need (int, int, int)")
        
        shape = BulletBoxShape(Vec3(0.5, 0.5, 0.5))
        n = BulletRigidBodyNode('Box')                            # 这个碰撞体的运动会影响父级的位置啊
        np = self.world.attach_new_node(n)
        n.set_mass(0.0)
        np.setCollideMask(BitMask32(0b00011001))     # block mask
        n.addShape(shape)
        n. set_python_tag("hook", np)
        n. set_python_tag("block", None)
        self.bulletworld.attach_rigid_body(n)
        
        p = Vec3(x + 0.5, y + 0.5, z + 0.5)
        np.set_pos(p)
        
        block = self.block_table[type]
        vp = block.copyTo(render)
        vp.reparentTo(np)
        vp.setScale(Vec3(1, 1, 1))
        
        d = self.block_data
        t = (x, y, z)
        if t in d:
            self.delblockapi(t)
        d[t] = np
        
            
    def testblockapi(self, t):
        return t in self.block_data

    def delblockapi(self, t):
        d = self.block_data
        np = d[t]
        n = np.node()
        self.bulletworld.remove(n)
        np.removeNode()
        del d[t]

    
    def setenemyapi(self):
        import random
        r = random.random
        p = Point3(r() * 20, r() * 20, 3)
        
        h = 1.8
        w = 0.4
        shape = BulletCapsuleShape(w, h - 2 * w, ZUp)
        enemy = BulletRigidBodyNode("enemy")
        enemy.addShape(shape)
        # ~ enemy.setGravity(10)
        enemy.setMass(10.0)
        enemyp = self.world.attach_new_node(enemy)
        enemy.set_python_tag("enemyhook", enemyp)
        enemy.set_python_tag("blood", 3)
        enemyp.setPos(p)
        enemyp.setH(90)
        enemyp.setCollideMask(BitMask32(0b01100001))    # enemy mask
        self.bulletworld.attach_rigid_body(enemy)

        ap = self.actor.copyTo(render)
        # ~ ap = self.cubef.copyTo(self.render)
        ap.reparentTo(enemyp)
        ap.setScale(0.3048) # 1ft = 0.3048m
        ap.setH(180)
        ap.setPos(0, 0, -1)
        
        frameB = TransformState.makePosHpr(Point3(0, 0, 0), Vec3(0, 0, 0))

        generic = BulletGenericConstraint(enemy, frameB, True)
        generic.setLinearLimit(0, 0, -1)
        generic.setLinearLimit(1, 0, -1)
        generic.setLinearLimit(2, 0, -1)
        generic.setAngularLimit(0, 0, 0)
        generic.setAngularLimit(1, 0, 0)
        generic.setAngularLimit(2, 0, 0)
        
        
        enemy.set_python_tag("constrainthook", generic)
        self.bulletworld.attach_constraint(generic)
    
    def cmd(self):
        pass


class FixedControl(Control):
    def __init__(self, page):
        self.page = page
        self.root = page.root
        
    def reg(self):
        self.root.accept('escape', self.do_exit)
        self.root.accept('f3', self.toggle_debug)
        
        
        
    def unreg(self):
        self.root.ignore("escape")
        self.root.ignore("f3")
        self.root.ignore("f12")
        
    def do_exit(self):
        self.page.cleanup()
        sys.exit(1)

        
    def toggle_debug(self):
        if self.page.debugp.is_hidden():
            self.page.debugp.show()
        else:
            self.page.debugp.hide()


class MoveControl(Control):
    def __init__(self, page):
        self.page = page
        self.root = page.root
        
        
    def reg(self):
        hx, hy = self.root.hsize
        if self.update not in self.root.mouse_update_list:
            self.root.mouse_update_list.append(self.mouse_update)
            self.root.update_list.append(self.update)
        else:
            raise Exception()
        
        @self.root.accept2("w")
        def f():
            self.page.speedy = 1
        @self.root.accept2("w-up")
        def f():
            if self.page.speedy == 1:
                self.page.speedy = 0
        @self.root.accept2("s")
        def f():
            self.page.speedy = -1
        @self.root.accept2("s-up")
        def f():
            if self.page.speedy == -1:
                self.page.speedy = 0
        @self.root.accept2("d")
        def f():
            self.page.speedx = 1
        @self.root.accept2("d-up")
        def f():
            if self.page.speedx == 1:
                self.page.speedx = 0
        @self.root.accept2("a")
        def f():
            self.page.speedx = -1
        @self.root.accept2("a-up")
        def f():
            if self.page.speedx == -1:
                self.page.speedx = 0
        
        @self.root.accept2("space")
        def jump():
            self.page.charactern.setMaxJumpHeight(16)
            self.page.charactern.setJumpSpeed(7.5)
            self.page.charactern.doJump()

        print("move reg")
        
        globals()["debug_dh"] = 0
        
        
    def unreg(self):
        self.root.mouse_update_list.remove(self.mouse_update)
        self.root.update_list.remove(self.update)
        self.root.ignore("w")
        self.root.ignore("w-up")
        self.root.ignore("s")
        self.root.ignore("s-up")
        self.root.ignore("d")
        self.root.ignore("d-up")
        self.root.ignore("a")
        self.root.ignore("a-up")
        
        self.page.speedx = 0
        self.page.speedy = 0
        self.page.charactern.setLinearMovement(Vec3(0 ,0, 0), True)
        print("move unreg")
    
    
    def update(self, dt):
        t = self.page.character.get_transform()
        p = t.get_mat().xform_point(Vec3(0, 0, 0.8))
        base.cam.set_pos(p)
        # ~ base.cam.setPos(t.get_mat().xform_point(Vec3(0, -4, 4)))        # 第三人称        
        self.page.glowCamera.set_pos(p)
    
    def mouse_update(self, dxy, p0, v):
        speed = Vec3(0, 0, 0)
        speed.set_x(self.page.speedx)
        speed.set_y(self.page.speedy)
        speed.normalize()
        speed *= 5
        self.page.charactern.setLinearMovement(speed, True)
        
        
        dx, dy = dxy
        dh = - dx * 0.1
        dp = - dy * 0.1
        base.cam.set_p(base.cam.get_p() + dp)
        self.page.glowCamera.set_p(self.page.glowCamera.get_p() + dp)
        self.page.charactern.setAngularMovement(dh * 60)
        
        # camera update        
        base.cam.set_h(self.page.character.get_h())
        self.page.glowCamera.set_h(self.page.character.get_h())
        
        
        
        
        
        p_from = p0 + v
        p_to = p0 + v * 10
            
            
        result = self.page.bulletworld.ray_test_closest(p_from, p_to, BitMask32(0b00000001))      # 只有ghost的末尾不是1
        if result.hasHit():
            n = result.getNode()
            if n.has_python_tag("block"):
                p = result.getHitPos()                                              
                p = p + result.getHitNormal() * (-0.05)
                x = p.x // 1 + 0.5
                y = p.y // 1 + 0.5
                z = p.z // 1 + 0.5
                self.page.cubef.set_pos(Vec3(x, y, z) - v * 0.005)
                self.page.cubef.show()
            else:
                self.page.cubef.hide()
        else:
            self.page.cubef.hide()
                
            

class Tool:
    # name: int
    # pic: texture
    
    # ~ def __init__(self, name, pic):
        # ~ self.name = name
        # ~ self.pic = TexturePool.loadTexture(pic)
        
    def hold(self):
        raise NotImplementedError()
        
    def release(self):
        raise NotImplementedError()
        

frame_pic = TexturePool.loadTexture("models/frame.png")
class HandsControl(Control):
    def __init__(self, page):
        self.page = page
        self.root = page.root
        self.left = None
        self.right = [None, None, None, None, None]
        self.point = 0
        
        
        self.right[0] = Gun()
        self.right[1] = BuildStick()
        self.right[2] = BuildBoss()
        self.right[3] = BS2()
        
        self.obj_frames = [None, None, None, None, None]
        self.obj_slots = [None, None, None, None, None]
        
        
    def reg(self):
        self.root.accept("1", self.change, [0])
        self.root.accept("2", self.change, [1])
        self.root.accept("3", self.change, [2])
        self.root.accept("4", self.change, [3])
        self.root.accept("5", self.change, [4])
        self.handbar = self.root.aspect2d.attach_new_node("handbar")
        
        cm_handslot = CardMaker("handslot")
        cm_handslot.set_frame(-0.06, 0.06, -0.06, 0.06)
        cm_handslotframe = CardMaker("handslotfram")
        cm_handslotframe.set_frame(-0.06, 0.06, -0.06, 0.06)
        for i in range(5):
            tool = self.right[i]
            if tool is None:
                tool = Tool.hand
            s = self.handbar.attach_new_node(cm_handslot.generate())
            s.setTexture(tool.pic)
            sf = self.handbar.attach_new_node(cm_handslotframe.generate())
            sf.setTexture(frame_pic)
            self.obj_frames[i] = sf
            self.obj_slots[i] = s
            
            
            x = (-0.5 + i * 0.2) * 0.6
            y = - 0.85
            
            s.setPos(x, 0,    y )
            
            sf.setPos(x, -1,    y )
            sf.setTransparency(TransparencyAttrib.MAlpha)
            if i == 0:
                sf.set_color(1, 1, 1, 1)
            else:
                sf.set_color(1, 1, 1, 0.5)
                
        tool = self.right[self.point]
        if tool is None:
            tool = Tool.hand
        tool.hold(self.page)
        
        
        
    def unreg(self):
        self.root.ignore("1")
        self.root.ignore("2")
        self.root.ignore("3")
        self.root.ignore("4")
        self.root.ignore("5")
        self.handbar.remove_node()
    
    def change(self, n):
        print("change", n)
        
        if n == self.point:
            return
        
        tool = self.right[self.point]
        if tool is None:
            tool = Tool.hand
        tool.release(self.page)
        
        self.point = n
        for i, tool in enumerate(self.right):
            if i == self.point:
                self.obj_frames[i].set_color(1, 1, 1, 1)
            else:
                self.obj_frames[i].set_color(1, 1, 1, 0.5)
                
        tool = self.right[self.point]
        if tool is None:
            tool = Tool.hand
        tool.hold(self.page)
            
        
class Hand(Tool):
    def __init__(self):
        self.name = "hand"
        self.pic = TexturePool.loadTexture("models/hand.png")
    
    def hold(self, page):
        pass
        
    def release(self, page):
        pass


Tool.hand = Hand()


class Gun(Tool):
    def __init__(self):
        self.name = "gun"
        self.pic = TexturePool.loadTexture("models/gun.png")
    
    def hold(self, page):
        base.accept('mouse1', self.shoot1, [page])
        base.accept('mouse3', self.shoot2, [page])
        
    def release(self, page):
        base.ignore("mouse1")
        base.ignore("mouse3")
        
    
    def shoot1(self, page):
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)
        v = pTo - pFrom
        v.normalize()
        pTo = pFrom + v * 100
        pFrom = pFrom + v
        
        # Raycast for closest hit
        result = page.bulletworld.ray_test_closest(pFrom, pTo, BitMask32(0b00000001))
        print("#")
        print( result.hasHit())
        print(result.getHitFraction())
        print(result.getNode())
        print(result.getHitPos())
        print(result.getHitNormal())
        print("#\n")
        
        if result.hasHit():
            p = result.getHitPos()
            n = result.getNode()
            if n.has_python_tag("enemyhook"):
                np = n.get_python_tag("enemyhook")
                c = n.get_python_tag("constrainthook")
                blood = n.get_python_tag("blood")
                blood -= 1
                if blood <= 0:
                    np.removeNode()
                    page.bulletworld.remove(n)
                    page.bulletworld.removeConstraint(c)
                    vp = page.ball.copyTo(render)
                    vp.setPos(p)
                else:
                    n.set_python_tag("blood", blood)
                    n.set_active(True)
                    n.apply_impulse(v * 50 + Vec3(0, 0, 50), Point3(0, 0, 0))
                    


    def shoot2(self, page):
        # Get from/to points from mouse click
        # ~ pMouse = base.mouseWatcherNode.getMouse()
        # ~ print(type(pMouse))
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)

        # Calculate initial velocity
        v = pTo - pFrom
        v.normalize()

        # Create bullet
        # ~ shape = BulletBoxShape(Vec3(0.5, 0.5, 0.5))
        shape = BulletSphereShape(0.05)
        bullet = BulletRigidBodyNode('Bullet')
        bullet.addShape(shape)
        bullet.setMass(2.0)
        bullet.setGravity(1.0)
        bullet.setLinearVelocity(v * 30)
        bulletp = page.world.attach_new_node(bullet)
        bulletp.setPos(pFrom + v * 1.5)
        bulletp.setCollideMask(BitMask32(0b00000001))
        # 抗高速穿过
        bullet.setCcdMotionThreshold(1e-7);
        bullet.setCcdSweptSphereRadius(0.50);

        page.bulletworld.attach_rigid_body(bullet)
        
        shape = BulletSphereShape(0.2)
        bh1 = BulletGhostNode('BulletHelp1')
        bh1.addShape(shape)
        bh1.setCcdMotionThreshold(1e-7);
        bh1.setCcdSweptSphereRadius(0.50);
        bh1p = page.world.attach_new_node(bh1)
        bh1p.setPos(pFrom + v * 1)
        bh1p.setCollideMask(BitMask32(0b00101010))
        
        
        page.bulletworld.attach_ghost(bh1)
        
        shape = BulletSphereShape(5)
        bh2 = BulletGhostNode('BulletHelp2')
        bh2.addShape(shape)
        bh2p = page.world.attach_new_node(bh2)
        bh2p.setPos(pFrom + v * 1)
        bh2p.setCollideMask(BitMask32(0b01010100))
        
        page.bulletworld.attach_ghost(bh2)
        
        t = (bullet, bh1, bh2)
        page.booms.append(t)
        
        def rm(task):
            if t in page.booms:
                page.booms.remove(t)
                page.bulletworld.removeRigidBody(bullet)
                page.bulletworld.removeGhost(bh1)
                page.bulletworld.removeGhost(bh2)
            return task.done

        taskMgr.doMethodLater(5, rm, 'doRemove', 
            appendTask=True)


    
        
class BuildStick(Tool):
    def __init__(self):
        self.name = "buildstick"
        self.pic = TexturePool.loadTexture("models/build.png")
    
    def hold(self, page):
        base.accept('mouse1', self.del_block, [page])
        base.accept('mouse3', self.set_block, [page])
        
    def release(self, page):
        base.ignore("mouse1")
        base.ignore("mouse3")
        
        
    def del_block(self, page):
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)
        v = pTo - pFrom
        v.normalize()
        pTo = pFrom + v * 10
        pFrom = pFrom + v
        
        # Raycast for closest hit
        result = page.bulletworld.ray_test_closest(pFrom, pTo, BitMask32(0b00000001))
        print("#del")
        print( result.hasHit())
        print(result.getHitFraction())
        print(result.getNode())
        print(result.getHitPos())
        print(result.getHitNormal())
        print("#\n")
        
        if result.hasHit():
            p = result.getHitPos()
            n = result.getNode()
            if n.has_python_tag("block"):
                p = p - result.getHitNormal() * 0.05
                x = p.x // 1
                y = p.y // 1
                z = p.z // 1
                if page.testblockapi((x, y ,z)):
                    page.delblockapi((x, y ,z))
                else:
                    print("#del no exist block?")
            else:
                pass
      



    def set_block(self, page):
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)
        v = pTo - pFrom
        v.normalize()
        pTo = pFrom + v * 10
        pFrom = pFrom + v
        
        # Raycast for closest hit
        result = page.bulletworld.ray_test_closest(pFrom, pTo, BitMask32(0b00000001))
        print("#set")
        print( result.hasHit())
        print(result.getHitFraction())
        print(result.getNode())
        print(result.getHitPos())
        print(result.getHitNormal())
        print("#\n")
        
        if result.hasHit():
            n = result.getNode()
            if n.has_python_tag("block"):
                p = result.getHitPos()
                p = p + result.getHitNormal() * 0.95
                x = round(p.x // 1)
                y = round(p.y // 1)
                z = round(p.z // 1)
                
                page.setblockapi((x, y ,z))
      

        
class BuildBoss(Tool):
    def __init__(self):
        self.name = "buildboss"
        self.pic = TexturePool.loadTexture("models/builds.png")
        self.apic = TexturePool.loadTexture("models/arrow1.png")
        
        
        self.card = None
        self.ts = None
        self.miss = None
        self.multi = []
        self.single = None
    
    @property
    def mat(self):
        if self.ts is None:
            return None
        else:
            return self.ts.get_mat()
    
    def hold(self, page):
        base.accept('mouse3', self.start, [page])
        base.accept('mouse3-up', self.end, [page])
        assert self.check not in page.root.mouse_update_list
        page.root.mouse_update_list.append(self.check)
        self.page = page
        
        if self.card is None:
            cm = CardMaker("build_arrow")
            cm.setFrame(-0.3, 0.3, -0.3, 0.3)
            card = page.world.attach_new_node(cm.generate())
            card.setTexture(self.apic)
            card.setPos(0, 0,   0)
            card.setTransparency(TransparencyAttrib.MAlpha)
            card.hide()
            self.card = card
        
        
    def release(self, page):
        page.root.mouse_update_list.remove(self.check)
        base.ignore('mouse3')
        base.ignore('mouse3-up')
        self.card.hide()
        del self.page
        
    def check(self, dxy, p_from, v):
        page = self.page
        
        result = page.bulletworld.ray_test_closest(p_from + v * 1, p_from + v * 10, BitMask32(0b00000001))
        if result.hasHit():
            n = result.get_node()
            if n.has_python_tag("block"):
                p = result.getHitPos()
                no = result.getHitNormal()
                
                p = p + no * (-0.05)
                x = round(p.x // 1)
                y = round(p.y // 1)
                z = round(p.z // 1)
                pos = Vec3(x, y, z)
                
                f = -no
                x = Vec3.up().dot(f)
                if x > 0.9:
                    p = 90
                    h = self.page.character.get_h()
                    h = - round(h / 90) * 90
                elif x < -0.9:
                    p = -90
                    h = self.page.character.get_h()
                    h = round(h / 90) * 90
                elif -0.1 < x < 0.1:
                    x = Vec3.right().dot(f)
                    y = Vec3.forward().dot(f)
                    h = math.atan2(y, x) / math.pi * 180 - 90
                    h = round(h / 90) * 90
                    p = 0
                else:
                    #print("?normal", no)
                    return
                
                
                ts = TransformState.make_pos_hpr(pos, (h, p, 0))
                self.ts = ts
                ts1 = TransformState.make_pos(Vec3(0.5, 0.5, 0.5))
                ts2 = TransformState.make_pos(Vec3(0, -0.505, 0))
                ts3 = TransformState.make_mat(ts2.mat * (ts.mat * ts1.mat))

                self.card.set_transform(ts3)
                self.card.show()
            else:
                self.card.hide()
                self.ts = None
        else:
            self.card.hide()
            self.ts = None
        
    
    def start(self, page):
        if self.ts is None:
            self.miss = True
            return 
        else:
            self.miss = False
            
        page.move_control.unreg()
        
        def f1(ch):
            self.multi.append(ch)
            if len(self.multi) > 2:
                self.multi = self.multi[-2:]
            elif len(self.multi) == 2:
                self.single = False
            
        page.root.accept("w", f1, ["w"])
        page.root.accept("s", f1, ["s"])
        page.root.accept("a", f1, ["a"])
        page.root.accept("d", f1, ["d"])
        page.root.accept("q", f1, ["q"])
        
        def f2(ch):
            if len(self.multi) == 0:
                return
            if self.single == False and len(self.multi) == 1:   # 按了两个键又松开，视为取消
                self.multi.remove(ch)
                return
            if self.multi[-1] == ch:
                self.grow()
            self.multi.remove(ch)
            
        page.root.accept("w-up", f2, ["w"])
        page.root.accept("s-up", f2, ["s"])
        page.root.accept("a-up", f2, ["a"])
        page.root.accept("d-up", f2, ["d"])
        page.root.accept("q-up", f2, ["q"])
        
    def end(self, page):
        if self.miss == True:
            self.miss = None
            return 
        else:
            self.miss = None
            
        
        page.root.ignore("w-up")
        page.root.ignore("s-up")
        page.root.ignore("d-up")
        page.root.ignore("a-up")
        page.root.ignore("q-up")
        page.root.ignore("w")
        page.root.ignore("s")
        page.root.ignore("d")
        page.root.ignore("a")
        page.root.ignore("q")
        
        page.move_control.reg()    
        self.ts = None
        self.multi = []
        self.single = True
        
    
    dir_table = {"w": Vec3.up(), "s": Vec3.down(), "a": Vec3.left(), "d": Vec3.right(), "q": Vec3.forward()}
    
    def grow(self):
        multi = self.multi
        
        if len(multi) == 1:
            dir = self.dir_table[multi[-1]]
            for i in count(1):
                p = intv(self.mat.xform_point(dir * i))
                if not self.page.testblockapi(p):
                    self.page.setblockapi(p)
                    break
        elif len(multi) == 2:
            dir = self.dir_table[multi[-1]]
            dir2 = self.dir_table[multi[-2]]
            x = dir.dot(dir2)
            if not -0.1 < x < 0.1:
                # 两个方向不是垂直关系
                return 
                
            jump = 1
            for i in count(1):
                p = intv(self.mat.xform_point(dir * i))
                if not self.page.testblockapi(p):
                    jump = i
                    break
            #直接摆放时，jump=1
            
            acc = [0]
            for j in count(1):
                flag = None
                for i in range(jump):
                    p = intv(self.mat.xform_point(dir2 * j + dir * i))
                    if self.page.testblockapi(p):
                        continue
                    else:
                        flag = "fail"
                        break
                else:
                    p = intv(self.mat.xform_point(dir2 * j + dir * (i + 1)))
                    if not self.page.testblockapi(p):
                        flag = "success"
                    else:
                        flag = "fail"
                if flag == "success":
                    acc.append(j)
                    continue
                else:
                    break
                        
            for j in count(-1, -1):
                flag = None
                for i in range(jump):
                    p = intv(self.mat.xform_point(dir2 * j + dir * i))
                    if self.page.testblockapi(p):
                        continue
                    else:
                        flag = "fail"
                        break
                else:
                    p = intv(self.mat.xform_point(dir2 * j + dir * (i + 1)))
                    if not self.page.testblockapi(p):
                        flag = "success"
                    else:
                        flag = "fail"
                if flag == "success":
                    acc.append(j)
                    continue
                else:
                    break
                    
            for j in acc:
                p = intv(self.mat.xform_point(dir2 * j + dir * jump))
                self.page.setblockapi(p)
                        
           
        
class BS2(Tool):
    def __init__(self):
        self.name = "bs2"
        self.pic = TexturePool.loadTexture("models/2.png")
    
    def hold(self, page):
        base.accept('mouse1', self.del_block, [page])
        base.accept('mouse3', self.set_block, [page])
        
    def release(self, page):
        base.ignore("mouse1")
        base.ignore("mouse3")
        
        
    def del_block(self, page):
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)
        v = pTo - pFrom
        v.normalize()
        pTo = pFrom + v * 10
        pFrom = pFrom + v
        
        # Raycast for closest hit
        result = page.bulletworld.ray_test_closest(pFrom, pTo, BitMask32(0b00000001))
        print("#del")
        print( result.hasHit())
        print(result.getHitFraction())
        print(result.getNode())
        print(result.getHitPos())
        print(result.getHitNormal())
        print("#\n")
        
        if result.hasHit():
            p = result.getHitPos()
            n = result.getNode()
            if n.has_python_tag("block"):
                p = p - result.getHitNormal() * 0.05
                x = p.x // 1
                y = p.y // 1
                z = p.z // 1
                if page.testblockapi((x, y ,z)):
                    page.delblockapi((x, y ,z))
                else:
                    print("#del no exist block?")
            else:
                pass
      



    def set_block(self, page):
        pFrom = Point3()
        pTo = Point3()
        base.camLens.extrude(Point3(0, 0, 0), pFrom, pTo)

        pFrom = render.getRelativePoint(base.cam, pFrom)
        pTo = render.getRelativePoint(base.cam, pTo)
        v = pTo - pFrom
        v.normalize()
        pTo = pFrom + v * 10
        pFrom = pFrom + v
        
        # Raycast for closest hit
        result = page.bulletworld.ray_test_closest(pFrom, pTo, BitMask32(0b00000001))
        print("#set")
        print( result.hasHit())
        print(result.getHitFraction())
        print(result.getNode())
        print(result.getHitPos())
        print(result.getHitNormal())
        print("#\n")
        
        if result.hasHit():
            n = result.getNode()
            if n.has_python_tag("block"):
                p = result.getHitPos()
                p = p + result.getHitNormal() * 0.95
                x = round(p.x // 1)
                y = round(p.y // 1)
                z = round(p.z // 1)
                
                page.setblockapi((x, y ,z), 2)
      
        
                
                

if __name__ == "__main__":
    game = MyFrame()
    base.run()

